#include <stdlib.h>

#include "apec.h"
#include "messages.h"

void allocate_level_rates(int nlev, struct LEVEL_RATES *level_rates) {

  int iLev;

  level_rates->qrecomb_total = 0.0;
  level_rates->qsatel_total  = 0.0;
  level_rates->qioniz_total  = 0.0;
  level_rates->ionc          = 0.0;
  level_rates->nlev          = nlev;
  if (nlev > 0) { 
    level_rates->qrecomb = (double *) malloc_safe(nlev*sizeof(double));
    level_rates->qsatel  = (double *) malloc_safe(nlev*sizeof(double));
    level_rates->qioniz  = (double *) malloc_safe(nlev*sizeof(double));
    for (iLev = 0;iLev<nlev;iLev++) {
      level_rates->qrecomb[iLev] = 0.0;
      level_rates->qsatel[iLev]  = 0.0;
      level_rates->qioniz[iLev]  = 0.0;
    }
  } else {
    level_rates->qrecomb = NULL;
    level_rates->qsatel  = NULL;
    level_rates->qioniz  = NULL;
  }    
}

void dealloc_level_rates(int Z, struct LEVEL_RATES *level_rates) {

  int rmJ;

  for (rmJ=1; rmJ<Z+1 ;rmJ++) {
    if (level_rates[rmJ-1].qrecomb!= NULL) free(level_rates[rmJ-1].qrecomb);
    if (level_rates[rmJ-1].qsatel != NULL) free(level_rates[rmJ-1].qsatel);
    if (level_rates[rmJ-1].qioniz != NULL) free(level_rates[rmJ-1].qioniz);
  }
}


