#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <stdio.h>

#include "messages.h"

#define MAXSTRLEN 128
#define ENTIRE_ION -1

struct atomstr {
  int Z;
  int rmJ;
  char File[MAXSTRLEN];
  struct atomstr *next;
};

int roman_number(char *roman);
int element_number(char *atom);

void parse_atom(char *inc_atoms, char *inc_ions, struct atomstr **atoms) {

  int Z;
  int rmJ=ENTIRE_ION;
  char atomname[MAXSTRLEN], roman[MAXSTRLEN];
  char *token;

  struct atomstr *ptr;

  /* Now, parse two strings: */
  /* inc_atoms: space or comma separated element names */
  /* ion_ions : comma separated ion names  */

  /* Start with inc_atoms */
  ptr = *atoms;
  token = strtok(inc_atoms, ",");
  while (token != NULL) {
    Z = element_number(token);
    rmJ = ENTIRE_ION;
    if (Z == -1) {
      message("parse_atom","Could not parse atom name %s",token);
    } else {
      if (ptr==NULL) {
	*atoms = (struct atomstr *) malloc(sizeof(struct atomstr));
	ptr = *atoms;
	ptr->next = NULL;
      } else {
	ptr->next = (struct atomstr *) malloc(sizeof(struct atomstr));
	ptr = ptr->next;
	ptr->next = NULL;
      }
      ptr->Z = Z;
      ptr->rmJ = rmJ;
      strcpy(ptr->File,token);
    }
    token = strtok(NULL, " ,");
  }

  /* Now do inc_ions */
  token = strtok(inc_ions, ",");
  while (token != NULL) {
    sscanf(token,"%s %s", atomname, roman);
    Z = element_number(atomname);
    rmJ = roman_number(roman);
    if ((Z == -1)||(rmJ == -1)) {
      message("parse_atom","Could not parse ion name %s",token);
    } else {
      if (ptr==NULL) {
	*atoms = (struct atomstr *) malloc(sizeof(struct atomstr));
	ptr = *atoms;
	ptr->next = NULL;
      } else {
	ptr->next = (struct atomstr *) malloc(sizeof(struct atomstr));
	ptr = ptr->next;
	ptr->next = NULL;
      }
      ptr->Z = Z;
      ptr->rmJ = rmJ;
      strcpy(ptr->File,token);
    }
    token = strtok(NULL, ",");
  }
}
