#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include "apec.h"
#include "messages.h"

/* Sorts energy levels into increasing energy, fixing all related links */
/* at the same time. */

void sort_ion_data(struct ELEMENT_ION_STATE *state) {

  int i, iLev, jLev, Nlev;
  int lev1, lev2, lev3, lev4;

  Nlev = state->ion_inf->nlev;

  /* And now for a really simple, slow, and working bubble sort */

  for (iLev=0;iLev<Nlev-1;iLev++) { 
    for (jLev=iLev+1;jLev<Nlev;jLev++) {
      if (state->lev_dat[iLev].energy > state->lev_dat[jLev].energy) { 
	/* Now, swap levels iLev+1 and jLev+1 EVERYWHERE in state */

	/* Swapping transition line data */
	for (i=0;i<state->ion_inf->nwv;i++) {
	  lev1 = -1; lev2 = -1; lev3 = -1; lev4 = -1; 
	  if (state->linerad_dat[i].lev_upper == iLev+1) lev1 = jLev+1;
	  if (state->linerad_dat[i].lev_upper == jLev+1) lev2 = iLev+1;
	  if (state->linerad_dat[i].lev_lower == iLev+1) lev3 = jLev+1;
	  if (state->linerad_dat[i].lev_lower == jLev+1) lev4 = iLev+1;
	  if (lev1 != -1) state->linerad_dat[i].lev_upper = lev1;
	  if (lev2 != -1) state->linerad_dat[i].lev_upper = lev2;
	  if (lev3 != -1) state->linerad_dat[i].lev_lower = lev3;
	  if (lev4 != -1) state->linerad_dat[i].lev_lower = lev4;	  
	}

	/* Swapping collisional excitation data */
	for (i=0;i<state->ion_inf->nexc;i++) {
	  lev1 = -1; lev2 = -1; lev3 = -1; lev4 = -1; 
	  if (state->colltrns_dat[i].lev_upper == iLev+1) lev1 = jLev+1;
	  if (state->colltrns_dat[i].lev_upper == jLev+1) lev2 = iLev+1;
	  if (state->colltrns_dat[i].lev_lower == iLev+1) lev3 = jLev+1;
	  if (state->colltrns_dat[i].lev_lower == jLev+1) lev4 = iLev+1;
	  if (lev1 != -1) state->colltrns_dat[i].lev_upper = lev1;
	  if (lev2 != -1) state->colltrns_dat[i].lev_upper = lev2;
	  if (lev3 != -1) state->colltrns_dat[i].lev_lower = lev3;
	  if (lev4 != -1) state->colltrns_dat[i].lev_lower = lev4;	  
	}

	/* Swapping satellite line data */
	for (i=0;i<state->ion_inf->nsatel;i++) {
	  lev1 = -1; lev2 = -1; lev3 = -1; lev4 = -1; 
	  if (state->satellite_dat[i].lev_upper == iLev+1) lev1 = jLev+1;
	  if (state->satellite_dat[i].lev_upper == jLev+1) lev2 = iLev+1;
	  if (state->satellite_dat[i].lev_lower == iLev+1) lev3 = jLev+1;
	  if (state->satellite_dat[i].lev_lower == jLev+1) lev4 = iLev+1;
	  if (lev1 != -1) state->satellite_dat[i].lev_upper = lev1;
	  if (lev2 != -1) state->satellite_dat[i].lev_upper = lev2;
	  if (lev3 != -1) state->satellite_dat[i].lev_lower = lev3;
	  if (lev4 != -1) state->satellite_dat[i].lev_lower = lev4;	  
	}

      }
    }
  }
}
