%
%  Test plasma_coco
%
import("chips");
import("plasma");
%
%  Create dummy arrays
%
variable N_cont = 100;
variable E_cont = 0.101*[1:N_cont:1]-0.0001;
variable Continuum = 10. + 5*cos(E_cont*2);
variable N_pseudo = 1000;
variable E_pseudo = 0.1*[1:N_pseudo:1]/10.0;
variable Pseudo = 0 + 0.0*cos(E_pseudo*2);
variable norm = 1.0;
variable keV = 1;
variable Nbin = 10000;
variable inpbinlo = 0.1*[1:Nbin:1]/90.0 - 0.05;

variable spec = plasma_coco(norm, N_cont, E_cont, Continuum, N_pseudo, E_pseudo, Pseudo, keV, inpbinlo, NULL);

curve(inpbinlo,spec);
()=chips_eval("simpleline");
()=chips_eval("symbol none");
()=chips_eval("redraw");
curve(E_cont,Continuum);
()=chips_eval("redraw");
