define zero_line() {
   
   variable lineArr, Z, rmJ, ll, ul;
   variable i, line, gp;
   
   if (_NARGS != 5) {
      usage("Call as zero_line(line, Z, rmJ, ll, ul)");
      return;
   }
   
   (lineArr, Z, rmJ, ll, ul) = ();
   variable N = lineArr["0"]._nrows;
   for (i=1;i<N+1;i++) {
      line = lineArr[string(i)];
      gp = where(line.Element==Z and line.Ion==rmJ and line.LowerLev==ll 
		 and line.UpperLev==ul);
      if (length(gp) > 0) line.Epsilon[gp] = 0.0;
   }
}

define zero_line_emis() {
 
   variable lineArr, Z, rmJ, max_emis;
   variable i, j, line, gp;
   
   if (_NARGS != 4) {
      usage("Call as zero_line_emis(line, Z, rmJ, max_emis)");
      return;
   }
   
   (lineArr, Z, rmJ, max_emis) = ();
   variable N = lineArr["0"]._nrows;
   for (i=1;i<N+1;i++) {
      line = lineArr[string(i)];
      gp = where(line.Element==Z and line.Ion==rmJ and line.Epsilon > max_emis);
      for (j=0;j<length(gp);j++) {
	 zero_line(lineArr, line.Element[gp[j]], line.Ion[gp[j]],
		   line.LowerLev[gp[j]], line.UpperLev[gp[j]]);
      }
      
   }
   
}
