%
%
%
% Ronnie Hoogerwerf, SAO, 01/07/2004
%

define noticelinefree(datasets,linefree) {

   %
   % Tell sherpa to issue NOTICE commands for dataset <datasets>
   % for the linefree regions contained in linefree.
   %

   variable dtsts, dataset,i,lf;

   % Make sure datasets is of type array.

   if (not (typeof(datasets) == Array_Type)) {
      dtsts = [datasets];
   } else {
      dtsts = datasets;
   }

   foreach (dtsts) {
      dataset = ();
      () = set_ignore_all(dataset);
      
      lf = @linefree;
      while (lf.next != NULL) {
	() = set_notice(dataset,lf.start,lf.end);
	lf = lf.next;
      }
      () = set_notice(dataset,lf.start,lf.end);

   }

}
