      subroutine columnden(type,abund,X,coolrt,dene,dT,df)
      
      implicit none

      include 'modevolve.h'

      real X(Nions),abund(num)
      real NZ(Nions)
      real kB,coolrt,chi,dene,dT,s,chie,df
      real NdotH,abN,abH,abHe,NdotOverNh,Nh,Nh0,N
      integer type,i,j,k
      parameter(kB = 1.38062E-16)
      parameter(NdotH = 1.6E4)           ! cm^-2 s^-1 Chevalier & Oergle
      parameter(NdotOverNh=1.E7)
      common/column/NZ,Nh0
      
      if (type.eq.0) s=1.                 ! Isobaric 
      if (type.eq.1) s=0                 ! Isochoric
      if ((type.ne.0).and.(type.ne.1)) then
         write(*,*) 'Error...type of cooling not correct in COLUMNDEN!'
         stop
      endif 

      abH = 10.**(abund(1)-12.0) ! Current H abundance
      abHe   = 10.**(abund(2)-12.) ! Current He abundance
      chie = (X(2) + abhe*(X(4) + 2.*X(5))) ! Relative to H, NOT nuclei
      Nh = (dene/chie)
      N = Nh*(1+abHe)
      chi = 1 + abhe + chie   ! Relative to H, NOT nuclei
      do 20 i=1,num
         abN = 10.**(abund(i)-abund(1))    ! Abundance relative to H
         do 10 j = 0,nj(i)
            k = index(i) + j
            NZ(k) = NZ(k)-kB*NdotOverNh*(1.5+s)*abN*(chi/chie)*
     $           X(k)*dT/((Nh/Nh0)*(coolrt*1.E-23))
c            NZ(k) = NZ(k) + (1.5+s)*abN*(chi/chie)*X(k)*df/N
 10      continue
 20   continue

      return
      end

      subroutine columninit(abund,X,dene)
      implicit none

      include 'modevolve.h'

      real NZ(Nions),abund(num),dene,abHe,mu,Nh0,X(Nions),chie
      integer i
      common/column/NZ,Nh0

      do 10 i=1,Nions
         NZ(i) = 0.
 10   continue

      abHe   = 10.**(abund(2)-12.) ! Current He abundance
      chie = (X(2) + abhe*(X(4) + 2.*X(5)))
      Nh0 = (dene/chie)

      return
      end

      subroutine columnout
      implicit none

      include 'modevolve.h'

      integer i,j,k
      real NZ(Nions)
      common/column/NZ
      data names/'H','He','C','N','O','Ne','Mg','Si','S',
     #		'Ar','Ca','Fe','Ni','Al'/
      data roman/'I','II','III','IV','V','VI','VII','VIII','IX','X',
     # 'XI','XII','XIII','XIV','XV','XVI','XVII','XVIII','XIX','XX',
     # 'XXI','XXII','XXIII','XXIV','XXV','XXVI','XXVII','XXVIII',
     #  'XXIX','XXX'/

c
c Note: Unit 20 should already have been opened by the 'header' subroutine,
c       and given an appropriate name.
c
      write(20,*) 'Column densities'
      do 20 i = 1,num
         do 10 j=0,nj(i)
            k = index(i) + j
            write(20,1000) names(i),roman(j+1),'=',NZ(k)
 10      continue
 20   continue
      close(unit=20)
 1000 format(A3,A7,A2,E15.5)
      return
      end
