
C==================================================================
      real function atanh(x)

      implicit none
      real x,result

      if ((x .eq. 1.0).or.(x.eq.-1.0)) then
         write(*,*) 'Bad value to atanh'
         atanh = 0.
         return
      end if

      if (x .lt. 1) then
         result = 0.5*alog((1+x)/(1-x))
      else
         x = 1/x
         result = 0.5*alog((1+x)/(1-x))
      end if

      atanh = result
      return
      end
C==================================================================
      real function cool_int(a1, a2, b, d)

      implicit none
c Calculates the value of \int_{a1}^{a2} a^3/((a+d)^(3.5) (a+b)).
c Cases depend upon value of b - d.  
c      a  = radius, b = beta, d = delta

      real v1, v2, other
      real a1, a2, b, c, d, result, x1, x2, t1, t2, k
      real atanh
      external atanh

      c = b - d

      if ((c .le. 0).and.(-c .lt. 0.05*(a1+d))) then
c         write(*,*) 'Approximating!:',-c/(a1+d)
         v1 = -2*(35*a1**3 + 70*a1**2*d+56*a1*d**2+16*d**3)/
     $        (35*(a1+d)**(3.5))
         v2 = -2*(35*a2**3 + 70*a2**2*d+56*a2*d**2+16*d**3)/
     $        (35*(a2+d)**(3.5))
         t1 = -2*(105*a1**3 + 126*a1**2*d + 72*a1*d**2 + 16*d**3)/
     $        (315*(a1 + d)**(4.5))
         t2 = -2*(105*a2**3 + 126*a2**2*d + 72*a2*d**2 + 16*d**3)/
     $        (315*(a2 + d)**(4.5))
         other = -c*(t2 - t1)
         result = v2 - v1 + other
      else
         v1 = 2*d*(45*(a1**2)*(b**2) - 45*(a1**2)*b*d +
     $        75*a1*(b**2)*d + 15*(a1**2)*(d**2) - 65*a1*b*(d**2)
     $        + 33*(b**2)*(d**2) + 20*a1*(d**3) - 26*b*(d**3)
     $        + 8*(d**4))/
     $        (15*(c**3)*((a1 + d)**(2.5)))
         v2 = 2*d*(45*(a2**2)*(b**2) - 45*(a2**2)*b*d + 75*a2*(b**2)*d
     $        + 15*(a2**2)*d**2 - 65*a2*b*(d**2) + 33*(b**2)*(d**2) +
     $        20*a2*(d**3) - 26*b*(d**3) + 8*(d**4))/
     $        (15*(c**3)*((a2 + d)**(2.5)))

         if (c .gt. 0) then
            x1 = sqrt((a1+d)/c)
            x2 = sqrt((a2+d)/c)
            other = 2*(b/c)**3/sqrt(c)*atan((x2-x1)/(1+x1*x2))
         else  ! c < 0
            if (a2 .gt. 0.0) then
               c = -c
               x1 = sqrt((a1+d)/c)
               x2 = sqrt((a2+d)/c)
               k = (x2 - x1)/(1-x1*x2)
               other = 2*((b/c)**3/sqrt(c))*atanh(k)
            else
               other = 0.0
            end if
         end if

         result = v2 - v1 + other

      end if
c      write(*,FMT='(8G9.2)') a1,a2,b,d,v1,v2,other,result
      if (result .lt. 0) then
         write(*,*) 'bad cooling.'
         write(*,FMT='(8G9.3)') a1,a2,b,d,v1,v2,v2-v1,other
         result = 0
      end if
      cool_int = result
      
      return
      end
