#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#define TRUE 1
#define FALSE 0
#define NUM 12
#define MAXBINS 10000
#define ALLION 220
#define MAXLINES 2000

void setup_raymond_(void);
void setup_bin_(int *Nbin, float *binmin, float *binsyz);
void rs93_equil_(float *T, float *dene);
void rs93_getdata_(float *, float *, float *, float *, 
		   float *, float *, float *, int *, 
		   float *, float *, float *, int *);
void rs93_getlines_(float *rs93_wavelen, float *rs93_fosc, 
		    float *rs93_linepwr, int *rs93_atom, 
		    int *rs93_ion, int *rs93_index, int *rs93_numlines);

int main(int argc, char *argv[]) {

  float T=1.e7;
  float dene=1.0;
  int Nbin=1000;
  float binmin=10.;
  float binsyz=10.;
  float rs93_wavelen[MAXLINES], rs93_fosc[MAXLINES];
  float rs93_linepwr[MAXLINES];
  int rs93_atom[MAXLINES], rs93_ion[MAXLINES], rs93_index[MAXLINES];
  int rs93_numlines, i;

  setup_raymond_(); 
  setup_bin_(&Nbin, &binmin, &binsyz);
  rs93_equil_(&T, &dene);
  rs93_getlines_(rs93_wavelen, rs93_fosc, rs93_linepwr, 
		 rs93_atom, rs93_ion, rs93_index, &rs93_numlines);

  for (i=0;i<rs93_numlines;i++) {
    printf("%4d %4d %4d %10.5e %10.5e\n",
	   rs93_atom[i], rs93_ion[i], rs93_index[i], 
	   rs93_wavelen[i], rs93_linepwr[i]);
  }
  
}
